var _a=require('@aminadav/aminode')
module.exports = function(options) {
    if (typeof options == 'string') {
        options = { storage:'file',filename: options }
    }

    var express = require('express')
    var app = express();
    app.use(function(req,res,next){
    	wait.launchFiber(next)
    })
    app.use(require('body-parser').json())
    app.use('/', express.static(__dirname + '/frontend'))
    app.use(function(req,res,next){wait.launchFiber(next)})
    app.use(function(req,res,next){
    	next()
    })
    app.get('/data.json', function(req, res) {
    	data(function(err,body){
        		res.send(body)
    	})
    })
    app.get('/data.array.json', function(req, res) {
        var obj = {}
        data(function(err,body){
	        var ar = body
	        for (var i in ar) {
	            obj[ar[i].name] = ar[i].value
	        }
	        res.send(obj)
	    })
    })
    app.put('/data.json', function(req, res) {
        if (options.storage=='file') {
            require('fs').writeFileSync(options.filename, JSON.stringify(req.body, null, '\t'))
            res.send({ ok: true })
        }
        if (options.storage=='aminode') {
        	storage_set(options.key,req.body)
        	res.send({ok:true})
        }
    })
    function data(callback) {
        if (options.storage=='file') {
            callback(null,JSON.parse(require('fs').readFileSync(options.filename), 'utf-8'))
        }
        else if(options.storage=='aminode'){
        	callback(null,storage_get(options.key))
        }
        else{
        	callback(new Error('json-edit you must specify connection or filename'))
        	throw new Error('json-edit you must specify connection or filename')
        }
    }
    var toReturn = function() {
        app.apply(this, arguments)
    }
    toReturn.get = function(path) {
    	data(function(err,body){
        	return _.get(body, path)
    	})
    }
    return toReturn;
}
