var app = angular.module('app', [])
    .controller('json-app', function($scope, $http) {
        $http.get('data.json').then(function(ans) {
            $scope.items=json2array (ans.data)            
            // $scope.items = ans.data
        })
        $scope.save = function() {
            $scope.json=array2json($scope.items)

            $http.put('data.json', $scope.json).then(function() {
                alert('saved!')
            })
        }
        $scope.remove=function(obj,index){
            obj.splice(index,1)
            // for(var i in obj){
            //     if(obj[i]==item) return delete obj[i]
            // }
        }
        $scope.new = function(obj) {
            var name = prompt('Enter new name')
            if (!name) return
            var x = prompt('Enter type (string/boolean/number)', 'string')
            if (x == 'string') obj.push({ name: name, value: 'value' })
            if (x == 'number') obj.push({ name: name, value: 0 })
            if (x == 'boolean') obj.push({ name: name, value: true })
            if (x == 'object') obj.push({ name: name, value: [{name:'a',value:'3'}] })
        }
        $scope.type = function(a) {
            return typeof a
        }
    })
    .controller('json',function($scope,$http){
        // $scope.array=[]
        // for(var i in $scope.items){
        //     $scope.array.push({name:i,value:$scope.items[i]})
        // }        
    })
    // .controller('item',function($scope){
    // 	$scope.type=typeof $scope.item
    // })

function json2array(json){
    var ans=[]
    for(var i in json){
        if(angular.isObject(json[i])){
                ans.push({name:i,value:json2array(json[i])})
        }
        else
                ans.push({name:i,value:json[i]})
    }
    return ans
}
function array2json(array){
    var ans={}
    for(var i in array){
            ans[array[i].name]=angular.isArray(array[i].value) ? array2json(array[i].value)   :  array[i].value
    }
    return ans
}